﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SL_Flex_ListBindingTechnique
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            c1FlexGrid1.AutoGenerateColumns = false;

            C1.Silverlight.FlexGrid.Column column = new C1.Silverlight.FlexGrid.Column();
            column.Header = "List Names";
            c1FlexGrid1.Columns.Add(column);

            BindGrid();
            c1FlexGrid1.CellFactory = new MyCellFactory();

        }

        private void BindGrid()
        {
            List<mainDataClassCollection> _mainDataList = new List<mainDataClassCollection>();

            for (int i = 0; i <= 5; i++)
            {
                _mainDataList.Add(new mainDataClassCollection(i));
            }

            System.Windows.Data.Binding bnd = new System.Windows.Data.Binding();
            bnd.Path = new PropertyPath("ListData");
            bnd.Mode = System.Windows.Data.BindingMode.TwoWay;
            bnd.UpdateSourceTrigger = System.Windows.Data.UpdateSourceTrigger.Default;
            c1FlexGrid1.Columns[0].Binding = bnd;

            c1FlexGrid1.ItemsSource = _mainDataList;

            c1FlexGrid1.AutoSizeColumns(0, 0, 0);
            c1FlexGrid1.AutoSizeRows(0, c1FlexGrid1.Rows.Count - 1, 0);

        }

    }

    public class MyCellFactory : C1.Silverlight.FlexGrid.CellFactory
    {
        public override void CreateCellContent(C1.Silverlight.FlexGrid.C1FlexGrid grid, System.Windows.Controls.Border bdr, C1.Silverlight.FlexGrid.CellRange rng)
        {
            base.CreateCellContent(grid, bdr, rng);

            C1.Silverlight.FlexGrid.C1FlexGrid chFlx = new C1.Silverlight.FlexGrid.C1FlexGrid();
            chFlx.ItemsSource = ((mainDataClassCollection)grid.Rows[rng.Row].DataItem).ListData;
            chFlx.HeadersVisibility = C1.Silverlight.FlexGrid.HeadersVisibility.None;
            grid.Rows[rng.Row].Height = 72;
            chFlx.AutoSizeRows(0, chFlx.Rows.Count - 1, 0);
            chFlx.AutoSizeColumns(0, 0, 0);
            bdr.Child = chFlx;
        }

    }

    public class mainDataClassCollection
    {
        List<myDataClass> _list;

        public mainDataClassCollection(int index)
        {
            _list = new List<myDataClass>();
            for (int i = 0; i <= 2; i++)
            {
                _list.Add(new myDataClass("Name " + index.ToString() + i.ToString()));
            }

        }

        public List<myDataClass> ListData
        {
            get { return _list; }
        }

    }

    public class myDataClass
    {
        string _name;
        public myDataClass(string _nm)
        {
            _name = _nm;
        }

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
    }

}
